// this program can be executed by RobotBASIC which is 
// available free from www.RobotBASIC.org

main:
  gosub Instructions
  gosub Initialization  
  //gosub Test
  
  r=0
  while true
    call MoveBot(r)                                       
    r++
    if r>4 then r=0
  wend
end

Instructions:
  
  xyText 200,5,"A Swarm Simulation Demo","Times New Roman",20,fs_Bold,magenta,white
  print
  print 
  SetColor Magenta 
  print "                           written by John Blankenship"
  print "                           suggested by Steven Canning"
  print
  SetColor Black
  print " The program as written has four security robots and one intruder."
  print
  print " The blue security robots all PATROL their local area looking for the red intruder."
  print " Note: They look generally forward and cannot see through bushes or too far away."
  print    
  print " The goal of the red robot is to find its way to one of the safe zones without"
  print " getting caught. You manually control the red robot's movements using the mouse."
  print  
  print " If any of the blue robots sees the red robot it will try to block it from the goal"
  print " by constantly moving between the red robot's current position and the goal."
  print                                                                       
  print " When the blue robot that sees the red one will also notify all the other security"
  print " robots to move toward the red robot's position."   
  print
  print " Ideally the blocking robot keeps the intruder from the safe zone long enough for the"
  print " swarm to find their way to the offender and surround him to force an apprehention."
  print
  print " You move the red robot by simply clicking the mouse somewhere.  This will cause the"
  print " red robot to move toward the clicked spot. It will automatically stop moving if it"
  print " encounters something in its path. It will be captured if it cannot avoid the blue bots."
  print
  print " With the current settings it is POSSIBLE for the intruder to win (but not likely)." 
  print
  print " The robot's leave a faint trail as they move to help you visualize their behavior."
  print
  print "                           PRESS ANY KEY TO START"
  WaitKey k
return

Initialization:
  // special parameters for each of the five robots
  dim robot[5,5]
  robot[0,0]= 150       // initial x   (these will be updated as the program runs)
  robot[0,1]= 200       // initial y
  robot[0,2]= 110       // initial compass heading
  robot[0,3]= "Patrol"  // name of subroutine to execute for this robot
  robot[0,4]= BLUE      // color of robot
  
  robot[1,0]= 267
  robot[1,1]= 433
  robot[1,2]= 210
  robot[1,3]= "Patrol"
  robot[1,4]= BLUE
  
  robot[2,0]= 650
  robot[2,1]= 200
  robot[2,2]= -110
  robot[2,3]= "Patrol"
  robot[2,4]= BLUE
  
  robot[3,0]= 800-267
  robot[3,1]= 433
  robot[3,2]= -210
  robot[3,3]= "Patrol"
  robot[3,4]= Blue
   
  robot[4,0]= 400
  robot[4,1]= 100+random(400)
  robot[4,2]= 0
  robot[4,3]= "MoveRedRobot"
  robot[4,4]= RED
  
  Rectangle 1,1,799,599 
  // create "bushes" to hid behind
  call MyCircle(200,160)  
  call MyCircle(250,250)
  call MyCircle(530,250)
  call MyCircle(280,100)
  call MyCircle(595,165)
  //call MyCircle()
  call MyCircle(595,440) 
  call MyCircle(200,435)
  call MyCircle(500,350)
  call MyCircle(300,350)
  call MyCircle(500,520)
  call MyCircle(475,130)
  call MyCircle(350,500)
  SetColor Green,Green
  Circle 750,250,850,350
  Circle -50,250,50,350
  SetColor White
  xyString 8,270,"S"
  xyString 8,285,"A" 
  xyString 8,300,"F"
  xyString 8,315,"E"
  xyString 785,270,"S"
  xyString 785,285,"A" 
  xyString 785,300,"F"
  xyString 785,315,"E"
  SetColor Black,White 
  Mx=0
  My=0
  Mb=0 
  LeaveTrails = True
  OnMouse ProcessMouse
  AllowEvents ON
  
return   

ProcessMouse:  
  // simply records mouse position when mouse is clicked
  n=LastMouse()
  ReadMouse xxx,yyy,bbb
  _Mx=xxx
  _My=yyy
  OnMouse ProcessMouse
return 

Test:   
  rLocate 150,200,110,15
  rinvisible gray,lightgreen
  rpen down
  for i=1 to 5
    rforward 75
    rturn -72
  next
   
  rLocate 267,433,210,15
  rinvisible gray,lightgreen    
  rpen down
  for i=1 to 5
  rforward 75
  rturn 72
  next
  
  rLocate 650,200,-110,15
  rinvisible gray,lightgreen
  rpen down
  for i=1 to 5
  rforward 75
  rturn 72
  next
  
  rLocate 800-267,433,-210,15
  rinvisible gray,lightgreen
  rpen down
  for i=1 to 5
  rforward 75
  rturn -72
  next
  rLocate 400,250,180,15,robot[4,4]
  end                                                  
return 

Sub MyCircle(x,y)  
  // used for drawing the "bushes" in the environment
  r=8
  SetColor LightGreen,LightGreen
  for i=1 to 10
    Circle x+random(15)-r,y+random(15)-r,x+random(15)+r,y+random(15)+r
  next
  SetColor Black,White
return   
              
sub MoveBot(r)
  // this section is required because RobotBASIC is only designed to control ONE robot at a time   
  // the variable r controls which robot is being controlled (0-4)
  // multiple robots are handled by re-initializing them in sequence (using their last position and orientation)
  // each robot moves using the subroutine currently named in the array robot[r,3]
  // the user should never have to modify this routine
  x=robot[r,0]
  y=robot[r,1]
  a=robot[r,2]
  linewidth 5
  setcolor white,white
  circle x-12,y-12,x+12,y+12 
  rLocate x,y,robot[r,2],15,robot[r,4]
  linewidth 1
  rinvisible gray,green
  if _LeaveTrails then rpen down
  gosub robot[r,3]
  // save this robot's position and orientation
  rGPS xx,yy
  robot[r,0]= xx
  robot[r,1]= yy
  robot[r,2]= rCompass()
  SetColor Black,White
return

MoveRedRobot: 
  // as written, the routine lets the user control the red robot using the mouse
  // this lets the red robot be "intelligent" showing the swarm can actually work
  // simply click the mouse where you want the red robot to move
  // when it is the red robot's turn, it will move toward the click position
  // the robot will stop moving when it reaches the click position or the max distance
  // allowed for moves (which ever comes first), unless blocked by obstacle
  // Mx,My is the destination if non zero  
  setcolor black
  MaxMove = 75
  if not(_Mx=0 and _My=0) // user clicked mouse
    rGPS rrx,rry // red robot's current position

    // find angle to destination
    DestAngle = round (RtoD(atan2(_Mx-rrx,_My-rry))+90)
    if DestAngle<0 then DestAngle+=360
    call TurnToAngle(DestAngle)
    MaxDist = round(sqrt( (_Mx-rrx)*(_Mx-rrx) + (_My-rry)*(_My-rry) ))
    if MaxDist>MaxMove then MaxDist = MaxMove
    for i=1 to MaxDist
      if rBumper()&4 then break  // don't move if blocked in front
      rForward 1
    next
    _Mx=0 // indicate move is complete
    _My=0
    if rSense(green)
      OverlayText 310,250,"Intruder","Times New Roman",30,fs_Bold,magenta,white
      OverlayText 320,320,"  Wins  ","Times New Roman",30,fs_Bold,magenta,white\end
    endif  
  endif
return



Sub TurnToAngle(a)
  if a<0 then a+=360 
  setcolor black  
  while rCompass()<>a
    rTurn 1
  wend
return  

Patrol:
   SetColor Black,White
   ScanDist = 130
   for i=1 to 75
     if rFeel() then break
     rForward 1
   next
   if i<75
     if rFeel()&3
       di = 1
     else
       di = -1
     endif
     // obstacle found on patrol
     rTurn -(90*di)
     rForward 5
     rTurn 90*di
     rforward 75-i
   endif 
   if (r=0) or (r=3)
     di= -1
   else
     di = 1
   endif  
   rTurn 72*di
   rTurn -90
   found = false
   for ii=1 to 12
     rTurn 15
     if (rLook(0)=Red) and (rRange()< ScanDist) and (rRange()>0) 
       // red robot is seen by robot #r
       found=true     
       // set the x value of the goal being sought by the red robot
       // determined by which robot sees the red robot
       if r<2 
         _GoalX = 50
       else
         _GoalX = 750
       endif
       // note: the following data could be used to calculate the red robot's position and save it
       // even though it can be calculated, for ease of use and speed,
       // this program will just look in the robot[] array for the red robot's current position
       //ScanDist = rRange()    // distance
       //aa = rCompass()  // angle
       // and of course the blue robot's current position
       // robot #r should try to BLOCK the red robot
       // all other robots should TRACK to the red robot (effectively surrounding it)
       for iii = 0 to 3
         if iii=r 
           robot[iii,3]="Block"
         else
           robot[iii,3]="Track"
         endif
       next
       break
     endif
   next
   if found
     gosub Block // don't wait till next time to start blocking
   else
     rTurn -90 // back to original heading after looking
   endif
return   
   
   


Avoid:
  if not(rBumper()&1) then rForward -1
  t = 90  // direction to turn
  if Random(100)<50 then t=-90  // turn both left and right at random for objects DIRECTLY in front
  if rFeel()&8 then t=90   // if object on one side, turn away
  if rFeel()&2 then t=-90
  rTurn t
  for i=1 to 30   
    if rFeel()&14 then break
    rForward 1
  next
  rTurn -t
return

Block:
  // this routine tries to move the current blue robot halfway between the red robot and the goal
  rrx = robot[4,0] // red's position could be calculated by robot who sees it, for a real application
  rry = robot[4,1] // for simulation, this is easier and faster  
  rGPS brx,bry // current blue robot's position
  GoalY=300
  // global variable _GoalX was set by the patrolling robot
  DestX = round ((rrx+_GoalX)/2)
  DestY = round ((rry+GoalY)/2)
  
  DestAngle = round (RtoD(atan2(DestX-brx,DestY-bry))+90)
  call TurnToAngle(DestAngle)
  // now move to position unless blocked
  MaxDist = round (sqrt( (DestX-brx)*(DestX-brx)+(DestY-bry)*(DestY-bry) )) 
  if MaxDist>50 then MaxDist=50
  for i=1 to MaxDist 
    // during move, check to see if blue bot is close enough to apprehend the red bot
    rGPS brx,bry    
    d = sqrt( (brx-rrx)*(brx-rrx)+ (bry-rry)*(bry-rry) )
    if d<36
      // caught him
      // first face him
      rGPS brx,bry // current blue robot's position
      rrx = robot[4,0] // red's position could be calculated by robot who sees it, for a real application
      rry = robot[4,1] // for simulation, this is easier and faster
      // find angle to destination
      DestAngle = round (RtoD(atan2(rrx-brx,rry-bry))+90)
      call TurnToAngle(DestAngle)
      // inform user the game is over      
      OverlayText 310,250,"Intruder","Times New Roman",30,fs_Bold,magenta,white
      OverlayText 270,320,"Apprehended","Times New Roman",30,fs_Bold,magenta,white\end
    endif 
    if rSense(green) then rForward -1\break   
    if rBumper()&14 then gosub Avoid \ break   // move to the side of blocking object
    rForward 1
  next          
return

Track:
  // this routine moves the current blue robot toward the red robot an amount MaxDist unless blocked
  // it automatically avoids objects (bushes or robots) in its path
  MaxDist = 50
  rGPS brx,bry // current blue robot's position
  rrx = robot[4,0] // red's position could be calculated by robot who sees it, for a real application
  rry = robot[4,1] // for simulation, this is easier and faster
  // find angle to destination
  DestAngle = round (RtoD(atan2(rrx-brx,rry-bry))+90)
  call TurnToAngle(DestAngle)
  for i=1 to MaxDist
    if rBumper() then break   // move to the side of blocking object
    rForward 1
  next
  // check if close enough to apprehend
  rGPS brx,bry    
  d = sqrt( (brx-rrx)*(brx-rrx)+ (bry-rry)*(bry-rry) )
  if d<35
    // caught him
    // first face him
    rGPS brx,bry // current blue robot's position
    rrx = robot[4,0] // red's position could be calculated by robot who sees it, for a real application
    rry = robot[4,1] // for simulation, this is easier and faster
    // find angle to destination
    DestAngle = round (RtoD(atan2(rrx-brx,rry-bry))+90)
    call TurnToAngle(DestAngle)
    // inform user the game is over      
    SetColor Black
    OverLayText 310,250,"Intruder","Times New Roman",30,fs_Bold,magenta,white
    OverLayText 270,320,"Apprehended","Times New Roman",30,fs_Bold,magenta,white\end
  endif
  if rFeel() then gosub Avoid
return

